package com.themes.keyboard.black.utils;

import com.themes.keyboard.black.data.bean.ConfigLayoutChild;
import com.themes.keyboard.black.data.bean.ServiceConfig;
import com.themes.keyboard.black.data.bean.ConfigLayoutBean;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.Map;

public class ConfigTheme {

    public static ServiceConfig initConfig(String path)  {
        String filePath = "keyboard.conf"; // 文件路径
        ServiceConfig config = parseConfig(path);

        return config;
    }

    public static ServiceConfig parseConfig(String filePath)   {
//        InputStream open = MyApp.myAppInstance.getAssets().open(filePath);
        ServiceConfig config = new ServiceConfig();
        try (BufferedReader br = new BufferedReader(new FileReader(filePath))) {
            String line;
            ConfigLayoutBean currentLayout = null;
            while ((line = br.readLine()) != null) {
                line = line.trim();
                if (line.isEmpty()) {
                    continue; // 跳过空行
                }
                if (line.startsWith("Version:")) {
                    config.setVersion(line.split(":")[1].trim());
                } else if (line.startsWith("SupportLayouts:")) {
                    config.setSupportLayouts(line.split(":")[1].trim());
                } else if (line.startsWith("HideHint:")) {
                    config.setHideHint(Integer.parseInt(line.split(":")[1].trim()));
                } else if (line.startsWith("LayoutStyle:")) {
                    config.setLayoutStyle(line.split(":")[1].trim());
                } else if (line.equals("KeyDefault") || line.equals("KeyMarkDefault") || line.equals("KeyFuncDefault")) {
                    LinkedHashMap<String, String> maps = config.getMaps();
                    maps.put(line, "");
                } else if (line.contains(":") && currentLayout == null) {
                    String[] parts = line.split(":");
                    String keyName = parts[0].trim();
                    String keyValue = parts[1].trim();

                    String latestKey = null;
                    LinkedHashMap<String, String> maps = config.getMaps();
                    for (Map.Entry<String, String> entry : maps.entrySet()) {
                        latestKey = entry.getKey();
                    }
                    if (latestKey != null) {
                        maps.put(latestKey, keyValue);
                    }
                } else if (line.startsWith("Row")) {
                    currentLayout = new ConfigLayoutBean(line.split(":")[0].trim());
                    config.addLayout(currentLayout);
                } else if (currentLayout != null) {
                    if (line.equals("Key")) {
                        String[] parts = line.split(":");
                        String keyName = parts[0].trim();
                        ConfigLayoutChild configLayoutChild = new ConfigLayoutChild(keyName);
                        currentLayout.addKey(configLayoutChild);
                    } else if (line.contains(":") && currentLayout.getLastKey().getBackground() == null) {
                        // 解析按键的其他属性（如 Label）
                        String[] parts = line.split(":");
                        String keyName = parts[0].trim();
                        String keyValue = parts[1].trim();
                        ConfigLayoutChild configLayoutChild = currentLayout.getLastKey();
                        if (keyName.equals("Label")) {
                            configLayoutChild.setLabel(keyValue);
                        }
                        if (keyName.equals("Background")) {
                            configLayoutChild.setBackground(keyValue);
                        }
                    } else {
                        if (line.equals("KeyShift") || line.equals("KeyDelete") || line.equals("KeyAlphaSymbol") || line.equals("KeyEmoji")
                                || line.equals("KeyMark")
                                || line.equals("KeySpace")
                                || line.equals("KeyEnter")) {
                            ConfigLayoutChild funcationConfigLayoutChild = new ConfigLayoutChild(line);
                            config.addKey(funcationConfigLayoutChild);
                        } else if (line.contains(":")) {
                            String[] parts = line.split(":");
                            String keyName = parts[0].trim();
                            String keyValue = parts[1].trim();
                            ConfigLayoutChild lastConfigLayoutChild = config.getLastKeyList();
                            if (keyName.equals("Label")) {
                                lastConfigLayoutChild.setLabel(keyValue);
                            }
                            if (keyName.equals("Background")) {
                                lastConfigLayoutChild.setBackground(keyValue);
                            }
                        }
                    }
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return config;
    }
}




